library dart_unit_converter;

enum TypeDataConvert { byte, bit, kiloByte, megaByte, gigaByte }

class UnitConverter {
  // Constant Value
  final double bitConstant = 8;
  final double kbConstant = 1024;
  final double mbConstant = 1048576;
  final double gbConstant = 1073741824;

  // Continous Convert is converter function that return String.
  // This function is converting from BYTE value, to flexible STRING value converter
  String continousDataConvert(int byte) {
    String value;
    double byteParsed = byte.toDouble();
    if (byte >= 0 && byte < (kbConstant)) {
      value = byteParsed.toStringAsFixed(0);
      return '$value B';
    } else if (byte >= (kbConstant) && byte < (mbConstant / 2)) {
      value = (byteParsed / kbConstant).toStringAsFixed(1);
      return '$value KB';
    } else if (byte >= (mbConstant / 2) && byte < (gbConstant / 2)) {
      value = (byteParsed / mbConstant).toStringAsFixed(2);
      return '$value MB';
    } else {
      value = (byteParsed / gbConstant).toStringAsFixed(2);
      return '$value GB';
    }
  }

  double convert(
    int value,
    TypeDataConvert typeFrom,
    TypeDataConvert typeTo,
  ) {
    if (typeFrom == TypeDataConvert.byte) {
      if (typeTo == TypeDataConvert.gigaByte) {
        return value / gbConstant;
      } else if (typeTo == TypeDataConvert.megaByte) {
        return value / mbConstant;
      } else if (typeTo == TypeDataConvert.kiloByte) {
        return value / kbConstant;
      } else {
        return value * bitConstant;
      }
    } else {
      return value.toDouble();
    }
  }
}
